//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
#include <System.hpp>
#include <Math.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "ievect"
#pragma link "ieview"
#pragma link "imageenview"
#pragma link "cspin"
#pragma link "CSPIN"
#pragma link "ievect"
#pragma link "ieview"
#pragma link "imageenview"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
IenVect1->Blank();
IenVect1->IEBitmap->Width = 1280;
IenVect1->IEBitmap->Height = 1024;
// spline resolution
Resolution = 20;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
IenVect1->RemoveAllObjects();
IenVect1->Blank();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::IenVect1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  int X, int Y)
{
IenVect1->RemoveAllObjects();
IenVect1->ObjPenColor[-1] = clBlack;
IenVect1->ObjPenWidth[-1] = 2;
IenVect1->MouseInteractVt = TIEMouseInteractVt()<<miPutPolyLine;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::IenVect1MouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  int X, int Y)
{
IenVect1->MouseInteractVt = TIEMouseInteractVt()<<miObjectSelect;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
polyCount = 0;
if (!IenVect1->ObjectsCount)
   return;
// simplify
polyCount = IenVect1->ObjPolylinePointsCount[-2];
for (int i = 0; i < polyCount; i++)
	{
	polyPoint[i].x = IenVect1->ObjPolylinePoints[-2][i].x;
	polyPoint[i].y = IenVect1->ObjPolylinePoints[-2][i].y;
	}
simplifyPolyline(0);
IenVect1->SetObjPolylinePoints(-2, polyPoint, polyCount);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
polyCount = 0;
if (!IenVect1->ObjectsCount)
   return;
// simplify
polyCount = IenVect1->ObjPolylinePointsCount[-2];
for (int i = 0; i <= polyCount; i++)
	{
	polyPoint[i].x = IenVect1->ObjPolylinePoints[-2][i].x;
	polyPoint[i].y = IenVect1->ObjPolylinePoints[-2][i].y;
	}
simplifyPolyline(MAX_DELAY_POINTS);
splineCount = CalculateSplineCR(polyPoint, splinePoint, polyCount + 1);
for (int i = 0; i <= splineCount; i++)
	{
	polyPoint[i].x = splinePoint[i].x;
	polyPoint[i].y = splinePoint[i].y;
	}
IenVect1->SetObjPolylinePoints(-2, polyPoint, splineCount);
polyCount = splineCount;
}
//---------------------------------------------------------------------------
// polyline simplification Douglas-Peucker
//---------------------------------------------------------------------------
TPoint __fastcall TForm1::VecMinInt2D(TPoint A, TPoint B)
{
// Result = A - B
TPoint Result;
Result.x = A.x - B.x;
Result.y = A.y - B.y;
return Result;
}
//---------------------------------------------------------------------------
TFloat __fastcall TForm1::DotProdInt2D(TPoint A, TPoint B)
{
// Dotproduct = A * B
TFloat Result;
Result = A.x * B.x + A.y * B.y;
return Result;
}
//---------------------------------------------------------------------------
TFloat __fastcall TForm1::NormSquaredInt2D(TPoint A)
{
// Square of the norm |A|
TFloat Result;
Result = A.x * A.x + A.y * A.y;
return Result;
}
//---------------------------------------------------------------------------
TFloat __fastcall TForm1::DistSquaredInt2D(TPoint A, TPoint B)
{
// Square of the distance from A to B
TFloat Result;
Result = NormSquaredInt2D(VecMinInt2D(A, B));
return Result;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DouglasPeucker2D(TFloat Tol2, TPoint *Orig,  TStringList *IndexList, int j, int k)
// Simplify polyline in OrigList between j and k. point index will be added to stringlist
// for each point that must be included
{
int i, MaxI;
TFloat MaxD2, CU, CW, B, DV2;
TPoint P0, P1, PB, U, W;
TPoint *listPoint;
// Is there anything to simplify?
if (k <= j + 1)
   return;

P0 = Orig[j];
P1 = Orig[k];
U  = VecMinInt2D(P1, P0); // Segment vector
CU = DotProdInt2D(U, U); // Segment length squared
MaxD2 = 0;
MaxI  = 0;

// Loop through points and detect the one furthest away
for (i = j; i < k; i++)
	{
	W  = VecMinInt2D(Orig[i], P0);
	CW = DotProdInt2D(W, U);
	// Distance of point Orig[i] from segment
	if (CW <= 0) 	  // Before segment
	  DV2 = DistSquaredInt2D(Orig[i], P0);
	else if (CW > CU) // Past segment
		DV2 = DistSquaredInt2D(Orig[i], P1);
	else
		{
		// Fraction of the segment
		try {
		  B = CW / CU;
		  }
		catch(...) {
		  B = 0; // in case CU = 0
		  }
		PB.x = RoundTo(P0.x + B * U.x, 0);
		PB.y = RoundTo(P0.y + B * U.y, 0);
		DV2 = DistSquaredInt2D(Orig[i], PB);
		}
	// test with current max distance squared
	if (DV2 > MaxD2)
	   {
	   // Orig[i] is a new max vertex
	   MaxI  = i;
	   MaxD2 = DV2;
	   }
	}
// If the furthest point is outside tolerance we must split
if (MaxD2 > Tol2) // error is worse than the tolerance
   {
   // split the polyline at the farthest vertex from S
   // Marker[MaxI] = true;  // mark Orig[maxi] for the simplified polyline
   listPoint = new TPoint;
   listPoint->x = Orig[MaxI].x;
   listPoint->y = Orig[MaxI].y;
   IndexList->AddObject(pxcf_PadLeft(IntToStr(MaxI), 10, '0'), (TObject*)listPoint);
   // recursively simplify the two subpolylines at Orig[maxi]
   DouglasPeucker2D(Tol2, Orig, IndexList, j, MaxI); // polyline Orig[j] to Orig[maxi]
   DouglasPeucker2D(Tol2, Orig, IndexList, MaxI, k); // polyline Orig[maxi] to Orig[k]
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::simplifyPolyline(int max_pts)
{
// Douglas-Peucker
int index, i, tolerance;
TPoint *listPoint;
TStringList *IndexList = new TStringList();
tolerance = CSpinEdit1->Value;
do
  {
  IndexList->Clear();
  DouglasPeucker2D(tolerance, polyPoint, IndexList, 0, polyCount);
  IndexList->Sort();
  for (i = 0; i < IndexList->Count; i++)
	  {
	  index = StrToInt(IndexList->Strings[i]);
	  listPoint = (TPoint*)(IndexList->Objects[i]);
	  polyPoint[i+1].x = listPoint->x;
	  polyPoint[i+1].y = listPoint->y;
	  }
  polyPoint[IndexList->Count + 1].x = polyPoint[polyCount-1].x;
  polyPoint[IndexList->Count + 1].y = polyPoint[polyCount-1].y;
  polyCount = IndexList->Count + 1;
  if (max_pts == 0)
	 break;
  }
while (IndexList->Count > max_pts);
while (IndexList->Count)
  {
  listPoint = (TPoint*)(IndexList->Objects[0]);
  delete listPoint;
  IndexList->Objects[0] = 0;
  IndexList->Delete(0);
  }
delete IndexList;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TForm1::pxcf_PadLeft(AnsiString inp_str, int duzina, char pad_chr)
// dodavanje (pad) raznih char livo
{
 AnsiString pad_str;
 int pad_len;
 inp_str = inp_str.Trim();
 pad_str = AnsiString::StringOfChar(pad_chr,duzina);
 inp_str = pad_str + inp_str;
 pad_len = inp_str.Length();
 inp_str = inp_str.SubString(pad_len-duzina+1,duzina);
 return inp_str;
}
//---------------------------------------------------------------------------
int __fastcall TForm1::CalculateSplineCR(TPoint *poly_pts, TPoint *spline_pts, int poly_count)
{
int i, Segment, seg_count;
structSplinePoint Current, Next;
for (i = 0; i < poly_count; i++)
    {
    P[i+1].x = (double)(poly_pts[i].x);
    P[i+1].y = (double)(poly_pts[i].y);
    }
//Duplicate start and end points
P [0]          = P [1];
P [poly_count+1] = P [poly_count];
//Loop along all the points, drawing a line to the next point
seg_count = 0;
for (i = 1; i < poly_count; i++)
  {
  //Calculate coefficients for this point
  splineComputeCoeffsCR (i);
  //Calculate the start point for the first segment
  splinePointCR (0, &Current);
  //Split into smaller segments
  for (Segment = 1; Segment <= Resolution; Segment++)
      {
      //Calculate end point
      splinePointCR ((double)Segment / Resolution, &Next);
      // save segment
	  spline_pts[seg_count].x = RoundTo(Current.x, 0);
	  spline_pts[seg_count].y = RoundTo(Current.y, 0);
	  seg_count++;
	  spline_pts[seg_count].x = RoundTo(Next.x, 0);
      spline_pts[seg_count].y = RoundTo(Next.y, 0);
      Current = Next;
      }
  }
return seg_count;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::splinePointCR(double t, structSplinePoint *Point)
{
  double t2, t3;
  //Square and cube of t
  t2 = t * t;
  t3 = t2 * t;
  //Calculate coordinates
  Point->x = ((A.x * t3) + (B.x * t2) + (C.x * t) + D.x) / 2;
  Point->y = ((A.y * t3) + (B.y * t2) + (C.y * t) + D.y) / 2;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::splineComputeCoeffsCR (int n)
{
  /*
  Computes coefficients for point n.
  This is a matrix transform:
    -1  3 -3  1
     2 -5  4 -1
    -1  0  1  0
     0  2  0  0
  */
  //x-coefficients
  A.x =    -P [n - 1].x + 3 * P [n].x - 3 * P [n + 1].x + P [n + 2].x;
  B.x = 2 * P [n - 1].x - 5 * P [n].x + 4 * P [n + 1].x - P [n + 2].x;
  C.x =    -P [n - 1].x                   + P [n + 1].x;
  D.x =                   2 * P [n].x;

  //y-coefficients
  A.y =    -P [n - 1].y + 3 * P [n].y - 3 * P [n + 1].y + P [n + 2].y;
  B.y = 2 * P [n - 1].y - 5 * P [n].y + 4 * P [n + 1].y - P [n + 2].y;
  C.y =    -P [n - 1].y                   + P [n + 1].y;
  D.y =                   2 * P [n].y;
}
//---------------------------------------------------------------------------

